#include <bits/stdc++.h>
#define FOR(i, n) for(int i = 0; i < (n); ++i)
#define REP(i, a, b) for(int i = (a); i < (b); ++i)
#define TRAV(i, a) for(auto & i : (a))
#define SZ(x) ((int)(x).size())
#define X first
#define Y second
#define MP std::make_pair
#define PR std::pair
typedef long long ll;
typedef std::pair<int, int> PII;
typedef std::vector<int> VI;

int n, m;
std::vector<VI> g;

VI col;
VI topo;
void dfs(int v){
	col[v] = 1;
	TRAV(ch, g[v]){
		if(col[ch] == 0) dfs(ch);
	}
	topo.push_back(v);
}

int dead, ans;
std::vector<bool> XD;
void najd(){
	VI dp(n);
	VI where(n, -1);
	for(int i = n-1; i >= 0; --i) if(!XD[i]){
		PII mx = MP(-1, -1);
		TRAV(ch, g[i]){
			auto cur = MP(dp[ch]+1, ch);
			if(cur > mx) mx = cur;
		}
		dp[i] = mx.X;
		where[i] = mx.Y;
	}
	int pos = 0;
	while(pos != -1){
		XD[pos] = true;
		if(pos != 0 && pos != n-1){
			XD[pos] = true;
			dead++;
		}
		pos = where[pos];
	}
	pos = where[0];
	while(pos != -1){
		TRAV(ch, g[pos]){
			if(!XD[ch]) g[0].push_back(ch);
		}
		ans++;
		pos = where[pos];
	}
}

std::vector<VI> ng;

int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n >> m;
	g.resize(n);
	FOR(i, m){
		int a, b;
		std::cin >> a >> b;
		a--;b--;
		g[a].push_back(b);
	}
	col.resize(n);
	XD.resize(n);
	FOR(i, n) if(col[i] == 0) dfs(i);
	std::reverse(topo.begin(), topo.end());
	VI KTO(n);
	FOR(i, n) KTO[topo[i]] = i;
	int ind = 0;
	ng.resize(n);
	TRAV(v, topo){
		TRAV(ch, g[v]){
			ng[ind].push_back(KTO[ch]);
		}
		ind++;
	}
	g = ng;
	while(dead < n-2){
		najd();
	}
	std::cout << ans;
	return 0;
}
